//+------------------------------------------------------------------+
//|                                                     Roulette.mq5 |
//|                                      Copyright 2011, JQS aka Joo |
//|                              https://login.mql5.com/ru/users/joo |
//+------------------------------------------------------------------+
#property copyright "Copyright 2011, JQS aka Joo"
#property link      "https://login.mql5.com/ru/users/joo"
#property version   "1.00"
#property script_show_inputs
//--- input parameters
input int StartCount=100000000;

//    
double select1[]; //  
double select2[]; //  
//
void OnStart()
{
  MathSrand((int)TimeLocal());//  

  //     
  double array[6]={100.0,80.0,40.0,10.0,1.0,-10.0};

  ArrayResize(select1,6);ArrayInitialize(select1,0.0);
  ArrayResize(select2,6);ArrayInitialize(select2,0.0);

  //         
  int h0=0,h1=0,h2=0,h3=0,h4=0,h5=0;


  //   
  int time_start=(int)GetTickCount();

  //   
  for(int i=0;i<StartCount;i++)
  {
    switch(Roulette(array,6))
    {
    case 0:  h0++;break;
    case 1:  h1++;break;
    case 2:  h2++;break;
    case 3:  h3++;break;
    case 4:  h4++;break;
    default: h5++;break;
    }
  }

  Print((int)GetTickCount()-time_start,"  -  ");
  Print("h5 ",h5, " ",h5*100.0/StartCount);
  Print("h4 ",h4, " ",h4*100.0/StartCount);
  Print("h3 ",h3, " ",h3*100.0/StartCount);
  Print("h1 ",h1, " ",h1*100.0/StartCount);
  Print("h0 ",h0, " ",h0*100.0/StartCount);
  Print("----------------");
}
//

//
// .
int Roulette(double &array[], int SizeOfPop)
{
  int    i=0,u=0;
  double p=0.0,start=0.0;

  double delta=(array[0]-array[SizeOfPop-1])*0.01-array[SizeOfPop-1];
//------------------------------------------------------------------------------
  //   
  for(i=0;i<SizeOfPop;i++)
  {
    select1[i]=start;
    select2[i]=start+MathAbs(array[i]+delta);
    start=select2[i];
  }

  //  ""
  p=RNDfromCI(select1[0],select2[SizeOfPop-1]);

  // ,     ""
  for(u=0;u<SizeOfPop;u++)
    if((select1[u]<=p && p<select2[u]) || p==select2[u])
      break;
//------------------------------------------------------------------------------
  return(u);
}
//

//
//      .
double RNDfromCI(double min,double max)
{return(min+((max-min)*MathRand()/32767.0));}
//
